<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.util.formatter.DateFormatter"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final Formatter dateFormat = new DateFormatter("yyyyMMdd");
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="css/reggie.css">
	<script language="JavaScript" src="reggie.js" type="text/javascript" charset="UTF-8"></script>
	
<style>
tr.highlight
{
	border-top: 1px dotted #A0A0A0;
}

.dottedleft
{
	border-left: 1px dotted #A0A0A0;
}

#detailsTable
{
	width: 100%; 
	border-collapse: collapse;
}

#detailsTable td
{
	text-align: center;
	min-width: 4.5em;
}

#detailsTable tbody td
{
	padding-top: 1px;
	padding-bottom: 1px;
}

#detailsTable .italic
{
	font-style: italic;
}

.nondefault
{
	background: #FFF066;
}
.nondefault:after
{
	content: '›';
}
.nondefault:before
{
	content: '‹';
}
.lightgray
{
	background: #E8E8E8;
}
</style>
	
<script language="JavaScript">

var DEFAULT_LYSATE_VOLUME = 700;
var DEFAULT_LYSATE_USED = 350;
var DEFAULT_DNA_VOLUME = 95;
var DEFAULT_RNA_VOLUME = 51;
var DEFAULT_FT_VOLUME = 550;

var debug = false;
var currentStep = 1;

var allLysates;
var selectedLysates;
var createdRna;

// Step 1
var lysatesIsValid = false;
// Step 2
var lysisDateIsValid = false;
var qiacubeDateIsValid = false;
var qiacubeRunNoIsValid = false;
// Step 3
var nanoDropFileIsValid = false;
var qiacubePositionsAreValid = false;

function init()
{
	if (!window.FileReader)
	{
		setFatalError('Your browser is not supported by this wizard. We recommend that latest Firefox version.');
		return;
	}
	var frm = document.forms['reggie'];

	allLysates = getUnprocessedLysates();
	
	var lysateList = frm.lysates;
	if (allLysates != null && allLysates.length > 0)
	{
		for (var i=0; i < allLysates.length; i++)
		{
			var lysate = allLysates[i];
			var name = (i+1) + ': ' + lysate.name;
			if (lysate.bioWell)
			{
				name += ' -- ' + lysate.bioWell.bioPlate.name + ' (' + lysate.bioWell.location+')';
			}
			var selected = i < 12;
			var option = new Option(name, lysate.id, selected, selected);
			option.lysate = lysate;
			lysateList.options[lysateList.length] = option;
		}
		lysatesOnChange();
	}
	else
	{
		setInputStatus('lysate', 'No Lysate available for processing.', 'invalid');
	}
	Main.show('gonext');
}

function getUnprocessedLysates()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading Lysate extracts...');
		var url = 'Extraction.servlet?ID=<%=ID%>&cmd=GetUnprocessedLysates';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.lysates;
}

function getProtocols(subtype)
{
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading ' + subtype + ' protocols...');
		var url = 'Protocol.servlet?ID=<%=ID%>&cmd=GetProtocols&subtype='+subtype;		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.protocols;
}

var lastQiacubeDate;

function getNextQiacubeRunNo()
{
	var frm = document.forms['reggie'];
	var qiacubeDate = frm.qiacubeDate.value;
	if (lastQiacubeDate == qiacubeDate)
	{
		return frm.qiacubeRunNo.value;;
	}
	lastQiacubeDate = qiacubeDate;
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading Qiacube run number...');
		var url = 'Extraction.servlet?ID=<%=ID%>&cmd=GetNextQiacubeRunNo&qiacubeDate='+qiacubeDate;		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.nextQiacubeRunNo;
}


function step1IsValid()
{
	return lysatesIsValid;
}

function step2IsValid()
{
	return lysisDateIsValid && qiacubeDateIsValid && qiacubeRunNoIsValid;
}

function step3IsValid()
{
	return nanoDropFileIsValid && qiacubePositionsAreValid;	
}

function goNextAuto()
{
	goNext(false);
}

function goNext(manual)
{
	var frm = document.forms['reggie'];
	setInnerHTML('gonext.message', '');
	if (currentStep == 1)
	{
		if (step1IsValid()) gotoStep2();
	}
	else if (currentStep == 2)
	{
		if (step2IsValid()) gotoStep3();
	}
	setCurrentStep(currentStep);
}

function gotoStep2()
{
	var frm = document.forms['reggie'];
	frm.lysates.disabled = true;
	
	selectedLysates = new Array();
	for (var i=0; i < frm.lysates.length; i++)
	{
		if (frm.lysates[i].selected)
		{
			selectedLysates.push(allLysates[i]);
		}
	}
	currentStep = 2;
	
	Main.show('gocancel');
	
	var lysisProtocols = getProtocols('SAMPLE_HANDLING_PROTOCOL');
	for (var i = 0; i < lysisProtocols.length; i++)
	{
		var protocol = lysisProtocols[i];
		frm.lysisProtocol[frm.lysisProtocol.length] = new Option(protocol.name, protocol.id, protocol.isDefault);		
	}
	if (frm.lysisProtocol.length == 0)
	{
		frm.lysisProtocol[0] = new Option('- none -', '');
	}

	var extractionProtocols = getProtocols('EXTRACTION_PROTOCOL');
	for (var i = 0; i < extractionProtocols.length; i++)
	{
		var name = extractionProtocols[i].name;
		var id = extractionProtocols[i].id;
		frm.dnaProtocol[frm.dnaProtocol.length] = new Option(name, id, false, name == 'AllprepCustomPartA');
		frm.rnaProtocol[frm.rnaProtocol.length] = new Option(name, id, false, name == 'AllprepMod1partC');
		frm.ftProtocol[frm.ftProtocol.length] = new Option(name, id, false, name == 'AllprepMod1partB');
	}
	if (frm.dnaProtocol.length == 0)
	{
		frm.dnaProtocol[0] = new Option('- none -', '');
		frm.rnaProtocol[0] = new Option('- none -', '');
		frm.ftProtocol[0] = new Option('- none -', '');
	}
	
	Main.show('step.2.section');
	Main.hide('step.1.section');
	Main.addClass(document.getElementById('step.1.section'), 'disabled');
	lysisOrQiacubeDateOnChange();
	frm.lysisDate.focus();
}

function gotoStep3()
{
	var frm = document.forms['reggie'];
	
	// Disable step2 fields
	frm.lysisDate.disabled = true;
	frm.lysisProtocol.disabled = true;
	frm.qiacubeDate.disabled = true;
	frm.qiacubeRunNo.disabled = true;
	frm.qiacubeOperator.disabled = true;
	frm.dnaProtocol.disabled = true;
	frm.rnaProtocol.disabled = true;
	frm.ftProtocol.disabled = true;
	
	currentStep = 3;
	
	var html = '<table id="detailsTable">';
	// First header row
	html += '<thead>';
	html += '<tr>';
	html += '<th>Specimen</th>';
	html += '<th class="dottedleft">Qiacube</th>';
	html += '<th colspan="3" class="dottedleft">Lysate</th>';
	html += '<th colspan="3" class="dottedleft">DNA</th>';
	html += '<th colspan="3" class="dottedleft">RNA</th>';
	html += '<th class="dottedleft">FT</th>';
	html += '<th class="dottedleft">Comment</th>';
	html += '</tr>';
	// Second header row
	html += '<tr>';
	html += '<th></th>';
	html += '<th class="dottedleft">position</th>';
	html += '<td class="dottedleft">Storage</td><td>Total</td><td>Used</td>';
	html += '<td class="dottedleft">Pos</td><td>Vol.</td><td>Conc.</td>';
	html += '<td class="dottedleft">Pos</td><td>Vol.</td><td>Conc.</td>';
	html += '<td class="dottedleft">Vol.</td>';
	html += '<td class="dottedleft"></td>';
	html += '</tr>';
	// Third header row
	html += '<tr style="border-bottom: 1px dotted #A0A0A0 !important;">';
	html += '<th></th>';
	html += '<th class="dottedleft"></th>';
	html += '<td class="dottedleft">box</td><td>(µl)</td><td>(µl)</td>';
	html += '<td class="dottedleft"></td><td>(µl)</td><td>(ng/µl)</td>';
	html += '<td class="dottedleft"></td><td>(µl)</td><td>(ng/µl)</td>';
	html += '<td class="dottedleft">(µl)</td>';
	html += '<td class="dottedleft"></td>';
	html += '</tr>';
	html += '</thead>';
	html += '<tbody>';
	
	// Set default values for DNA/RNA extraction
	for (var i = 0; i < selectedLysates.length; i++)
	{
		var lysate = selectedLysates[i];
		lysate.originalQuantity = DEFAULT_LYSATE_VOLUME;
		lysate.processedQuantity = DEFAULT_LYSATE_USED;
		lysate.qiacubePosition = i+1;
		lysate.originalQiacubePosition = i+1;
		
		var rna = new Object();
		var dna = new Object();
		var ft = new Object();
		// DNA
		dna.name = lysate.name + '.d';
		dna.volume = DEFAULT_DNA_VOLUME;
		
		// RNA
		rna.name = lysate.name + '.r';
		rna.volume = DEFAULT_RNA_VOLUME;
		
		// FlowThrough
		ft.name = lysate.name + '.f';
		ft.volume = DEFAULT_FT_VOLUME;
		
		lysate.rna = rna;
		lysate.dna = dna;
		lysate.ft = ft;
		
		html += '<tr class="highlight">';
		html += '<th>' + lysate.name.replace(/\.l$/, '') + '</th>';
		html += '<td id="qiacubePosition'+i+'" class="dottedleft"></td>';
		html += '<td class="dottedleft">'+lysate.bioWell.bioPlate.name + '[' + lysate.bioWell.location+']</td>';
		html += '<td id="lysateTotal'+i+'"></td>';
		html += '<td id="lysateUsed'+i+'"></td>';
		html += '<td id="dnaPos'+i+'" class="dottedleft"></td>';
		html += '<td id="dnaVol'+i+'"></td>';
		html += '<td id="dnaConc'+i+'" class="lightgray italic"></td>';
		html += '<td id="rnaPos'+i+'" class="dottedleft"></td>';
		html += '<td id="rnaVol'+i+'"></td>';
		html += '<td id="rnaConc'+i+'" class="lightgray italic"></td>';
		html += '<td id="ftVol'+i+'" class="dottedleft"></td>';
		html += '<td id="comments'+i+'" class="dottedleft"></td>';
		html += '<td><div class="basicbutton" onclick="editDnaRnaDetails('+i+')"><div>Edit...</div></div></td>';
		html += '</tr>';
	}

	html += '<tr style="border-top: 1px solid transparent;"><td style="padding: 0px;" colspan="11"></td></tr>';
	html += '</tbody>';
	html += '</table>';
	document.getElementById('detailsSection').innerHTML = html;
	
	updateDetailsTable();
	
	Main.show('step.3.section');
	Main.hide('step.2.section');
	Main.addClass(document.getElementById('step.2.section'), 'disabled');
	setInputStatus('nanoDropFile', 'No file selected', 'invalid');
	Main.hide('gonext');
	Main.show('gocreate');
	
	if (debug) Main.show('generateFakeMeasurementsFile');
}

function editDnaRnaDetails(index)
{
	if (currentStep != 3) return;
	var url = 'edit_dnarna_details.jsp?ID=<%=ID%>&index='+index;
	url += '&lysate=' + selectedLysates[index].name;
	Main.openPopup(url, 'EditDnaRnaDetails', 600, 400);	
}

function updateDetailsTable()
{
	var hasQiacubePosition = new Array();
	var duplicatePosition = 0;
	
	for (var i = 0; i < selectedLysates.length; i++)
	{
		var lysate = selectedLysates[i];	
		setInnerHTML('qiacubePosition'+i, lysate.qiacubePosition);
		addOrRemoveClass('qiacubePosition'+i, 'nondefault', lysate.qiacubePosition != lysate.originalQiacubePosition);
		if (hasQiacubePosition[lysate.qiacubePosition])
		{
			duplicatePosition = lysate.qiacubePosition;
		}
		else
		{
			hasQiacubePosition[lysate.qiacubePosition] = true;
		}
		
		// Calculate NanoDrop well from Qiacube position
		var row;
		var col;
		if (lysate.qiacubePosition > 8)
		{
			row = lysate.qiacubePosition - 9;
			col = 2;
		}
		else
		{
			row = lysate.qiacubePosition - 1;
			col = 1;
		}
		lysate.dna.well = WELL_ALPHA[row] + col;
		lysate.rna.well = WELL_ALPHA[row] + (col+2);
		
		setInnerHTML('lysateTotal'+i, lysate.originalQuantity);
		addOrRemoveClass('lysateTotal'+i, 'nondefault', lysate.originalQuantity != DEFAULT_LYSATE_VOLUME);
		setInnerHTML('lysateUsed'+i, lysate.processedQuantity);
		addOrRemoveClass('lysateUsed'+i, 'nondefault', lysate.processedQuantity != DEFAULT_LYSATE_USED);
		setInnerHTML('dnaPos'+i, lysate.dna.well);
		addOrRemoveClass('dnaPos'+i, 'nondefault', lysate.qiacubePosition != lysate.originalQiacubePosition);
		setInnerHTML('dnaVol'+i, lysate.dna.volume);
		addOrRemoveClass('dnaVol'+i, 'nondefault', lysate.dna.volume != DEFAULT_DNA_VOLUME);
		setInnerHTML('dnaConc'+i, formatNumber(lysate.dna.ndConc) || '-');
		var dnaConc = document.getElementById('dnaConc'+i);
		dnaConc.title = '260/280=' + lysate.dna.nd260by280 + '\n260/230=' + lysate.dna.nd260by230;
		setInnerHTML('rnaPos'+i, lysate.rna.well);
		addOrRemoveClass('rnaPos'+i, 'nondefault', lysate.qiacubePosition != lysate.originalQiacubePosition);
		setInnerHTML('rnaVol'+i, lysate.rna.volume);
		addOrRemoveClass('rnaVol'+i, 'nondefault', lysate.rna.volume != DEFAULT_RNA_VOLUME);
		setInnerHTML('rnaConc'+i, formatNumber(lysate.rna.ndConc) || '-');
		var rnaConc = document.getElementById('rnaConc'+i);
		rnaConc.title = '260/280=' + lysate.rna.nd260by280 + '\n260/230=' + lysate.rna.nd260by230;
		setInnerHTML('ftVol'+i, lysate.ft.volume);
		addOrRemoveClass('ftVol'+i, 'nondefault', lysate.ft.volume != DEFAULT_FT_VOLUME);
		
		if (lysate.comment || lysate.dna.comment || lysate.rna.comment || lysate.ft.comment)
		{
			setInnerHTML('comments'+i, 'Yes');
			addOrRemoveClass('comments'+i, 'nondefault', true);
			var tooltip = new Array();
			if (lysate.comment) tooltip[tooltip.length] = 'Lysate: ' + lysate.comment;
			if (lysate.dna.comment) tooltip[tooltip.length] = 'DNA: ' + lysate.dna.comment;
			if (lysate.rna.comment) tooltip[tooltip.length] = 'RNA: ' + lysate.rna.comment;
			if (lysate.ft.comment) tooltip[tooltip.length] = 'FlowThrough: ' + lysate.ft.comment;
			var cmnt = document.getElementById('comments'+i);
			cmnt.title = tooltip.join('\n');
		}
		else
		{
			setInnerHTML('comments'+i, '');
			addOrRemoveClass('comments'+i, 'nondefault', false);
			var cmnt = document.getElementById('comments'+i);
			cmnt.title = null;
		}
		
	}
	
	if (duplicatePosition)
	{
		setInputStatus('downloadSampleIdFile', 'Duplicate Qiacube position: ' + duplicatePosition, 'invalid');
		qiacubePositionsAreValid = false;
	}
	else
	{
		setInputStatus('downloadSampleIdFile', '', '');
		qiacubePositionsAreValid = true;
	}
}

function addOrRemoveClass(id, className, addIfTrue)
{
	Main.addOrRemoveClass(document.getElementById(id), className, addIfTrue);	
}

function goCreate()
{
	if (!step3IsValid()) return;
	var frm = document.forms['reggie'];
	
	frm.nanoDropFile.disabled = true;
	Main.hide('generateFakeMeasurementsFile');
	Main.hide('gocreate');
	Main.hide('gocancel');
	Main.addClass(document.getElementById('step.3.section'), 'disabled');
	currentStep = 4;
	
	var submitInfo = new Object();
	submitInfo.lysates = selectedLysates;
	submitInfo.lysisDate = frm.lysisDate.value;
	submitInfo.lysisProtocol = parseInt(frm.lysisProtocol.value);
	submitInfo.qiacubeDate = frm.qiacubeDate.value;
	submitInfo.qiacubeRunNo = parseInt(frm.qiacubeRunNo.value);
	submitInfo.qiacubeOperator = frm.qiacubeOperator.value;
	submitInfo.dnaProtocol = parseInt(frm.dnaProtocol.value);
	submitInfo.rnaProtocol = parseInt(frm.rnaProtocol.value);
	submitInfo.ftProtocol = parseInt(frm.ftProtocol.value);

	if (debug) Main.debug(JSON.stringify(submitInfo));
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Working...');
		var url = 'Extraction.servlet?ID=<%=ID%>&cmd=RegisterDnaRnaFt';
		request.open("POST", url, false);
		request.setRequestHeader("Content-Type", "application/json");
		request.send(JSON.stringify(submitInfo));
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	
	var response = JSON.parse(request.responseText);
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	
	var msg = '<ul>';
	for (var i = 0; i < response.messages.length; i++)
	{
		msg += '<li>' + response.messages[i];
	}
	msg += '</ul>';
	setInnerHTML('done', msg);
	Main.show('done');
	Main.show('gorestart');
	
	if (response.createdRna && response.createdRna.length > 0)
	{
		createdRna = response.createdRna;
		Main.show('rnaQcWizard');	
	}
}

function goRnaQc()
{
	var url = 'rnaqc_aliquot.jsp?ID=<%=ID%>';
	for (var i = 0; i < createdRna.length; i++)
	{
		url += '&rna='+createdRna[i];
	}
	location.href = url;
}

function lysatesOnChange()
{
	lysatesIsValid = false;
	
	var frm = document.forms['reggie'];
	var lysateList = frm.lysates;
	
	var numSelected = 0;
	for (var i = 0; i < lysateList.length; i++)
	{
		if (lysateList[i].selected) numSelected++;
	}
	
	if (numSelected != 12)
	{
		setInputStatus('lysate', 'Must select 12 items.', 'invalid');
		return;
	}
	
	lysatesIsValid = true;
	setInputStatus('lysate', '', 'valid');
}

function lysisOrQiacubeDateOnChange()
{
	var frm = document.forms['reggie'];
	lysisDateIsValid = checkRequiredDate('lysisDate');
	var isValid = checkRequiredDate('qiacubeDate');
	
	if (isValid && lysisDateIsValid)
	{
		var lysisDate = Dates.parseString(frm.lysisDate.value, 'yyyyMMdd');
		var qiacubeDate = Dates.parseString(frm.qiacubeDate.value, 'yyyyMMdd');
		if (lysisDate > qiacubeDate)
		{
			setInputStatus('qiacubeDate', 'Qiacube date is before Lysis date', 'invalid');
			isValid = false;
		}
	}
	
	qiacubeDateIsValid = isValid;
	if (qiacubeDateIsValid)
	{
		frm.qiacubeRunNo.value = getNextQiacubeRunNo();
		qiacubeRunNoOnChange();
	}
}

function qiacubeRunNoOnChange()
{
	var frm = document.forms['reggie'];
	var runNumber = frm.qiacubeRunNo.value;
	qiacubeRunNoIsValid = false;

	if (runNumber == '')
	{
		setInputStatus('qiacubeRunNo', 'Missing', 'invalid');
		return;
	}
	if (!(parseInt(runNumber) >= 1))
	{
		setInputStatus('qiacubeRunNo', 'Must be at least 1', 'invalid');
		return;		
	}
	setInputStatus('qiacubeRunNo','', 'valid');
	qiacubeRunNoIsValid = true;
}


function checkRequiredDate(dateField)
{
	var frm = document.forms['reggie'];
	setInputStatus(dateField, '', '');
	
	var dateValue = frm[dateField].value;
	if (dateValue == '')
	{
		setInputStatus(dateField, 'Missing', 'invalid');
		return false;
	}
	else
	{
		// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.		
		dateValue = autoFillDate(dateValue);
		frm[dateField].value = dateValue;
		if (!Dates.isDate(dateValue, 'yyyyMMdd'))
		{
			setInputStatus(dateField, 'Not a valid date', 'invalid');
			return false;
		}
	}
	setInputStatus(dateField, '', 'valid');
	return true;
}

function downloadSampleIdFile()
{
	if (!qiacubePositionsAreValid)
	{
		alert('Qiacube positions are not valid. Please fix before downloading the file.');
		return;
	}
	
	var lysateNames = new Array();
	var frm = document.forms['reggie'];
	var url = 'Extraction.servlet?ID=<%=ID%>&cmd=DownloadNanoDropSampleIdFile';
	url += '&qiacubeDate='+frm.qiacubeDate.value;
	url += '&qiacubeRunNo='+frm.qiacubeRunNo.value;
	
	for (var i = 0; i < selectedLysates.length; i++)
	{
		var lysate = selectedLysates[i];
		lysateNames[lysate.qiacubePosition-1] = lysate.name;
	}
	url += '&lysateNames=' + lysateNames.join(',');
	window.location = url;
}


function nanoDropFileOnChange()
{
	var frm = document.forms['reggie'];
	var file = frm.nanoDropFile.files[0];
	
	var reader = new FileReader();
	
	reader.onload = nanoDropFileLoaded;
	reader.readAsText(file);
}

function nanoDropFileLoaded(event)
{
	parseNanoDropFile(event.target.result);
}


function parseNanoDropFile(data)
{
	nanoDropFileIsValid = false;

	try
	{
		// Reset the existing values
		for (var i = 0; i < selectedLysates.length; i++)
		{
			var lysate = selectedLysates[i];
			lysate.dna.ndConc = null;
			lysate.dna.nd260by280 = null;
			lysate.dna.nd260by230 = null;
			lysate.rna.ndConc = null;
			lysate.rna.nd260by280 = null;
			lysate.rna.nd260by230 = null;
		}
		
		var lines = data.split(/[\n\r]+/);
		var columns = lines[0].split(/ *\t */);
		
		var sampleIndex = findColumn(columns, 'Sample ID');
		if (sampleIndex == -1) return;
		
		var wellIndex = findColumn(columns, 'Well');
		if (wellIndex == -1) return;
		
		var ndConcIndex = findColumn(columns, 'Conc.');
		if (ndConcIndex == -1) return;
		
		var nd260by280Index = findColumn(columns, '260/280');
		if (nd260by280Index == -1) return;
		
		var nd260by230Index = findColumn(columns, '260/230');
		if (nd260by230Index == -1) return;
	
		var numImported = 0;		
		for (var i = 1; i < lines.length; i++)
		{
			if (lines[i].match(/^\s*$/)) continue; // Ignore empty lines
			
			var row = lines[i].split(/ *\t */);
			if (row.length != columns.length) 
			{
				setInputStatus('nanoDropFile', 'On line ' + (i+1) + '; Unexpected number of columns: ' + row.length);
				return;
			}
			
			var sampleId = row[sampleIndex];
			if (!sampleId || sampleId == 'blank') continue; // with the next line
	
			var rnaOrDna = findRnaOrDna(sampleId, i+1);
			if (!rnaOrDna) return;  // This is an error condition
			
			if (rnaOrDna.well != row[wellIndex])
			{
				setInputStatus('nanoDropFile', 'On line ' + (i+1) + '; Expected to find "' + sampleId + '" in well [' + rnaOrDna.well + '] not ['  + row[wellIndex] + ']', 'invalid');
				return;
			}
			
			var ndConc = getNumber(row[ndConcIndex]);
			if (isNaN(ndConc))
			{
				setInputStatus('nanoDropFile', 'On line ' + (i+1) + '; No valid NDConc value for "' + sampleId + '": ' + row[ndConcIndex], 'invalid');
				return;
			}
			
			// If there are multiple entries for the same item, keep the largest NDConc
			if (!rnaOrDna.ndConc || ndConc > rnaOrDna.ndConc)
			{
				var nd260by280 = getNumber(row[nd260by280Index]);
				if (isNaN(nd260by280))
				{
					setInputStatus('nanoDropFile', 'On line ' + (i+1) + '; No valid 260/280 value for "' + sampleId + '": ' + row[nd260by280Index], 'invalid');
					return;
				}
				
				var nd260by230 = getNumber(row[nd260by230Index]);
				if (isNaN(nd260by230))
				{
					setInputStatus('nanoDropFile', 'On line ' + (i+1) + '; No valid 260/230 value for "' + sampleId + '": '+row[nd260by230Index], 'invalid');
					return;
				}
				
				// Store values
				rnaOrDna.ndConc = ndConc;
				rnaOrDna.nd260by280 = nd260by280;
				rnaOrDna.nd260by230 = nd260by230;

				numImported++;
			}
			
		}
	
		if (numImported != 24)
		{
			setInputStatus('nanoDropFile', 'Could not find values for all 24 samples: ' + numImported, 'invalid');	
			return;
		}

		setInputStatus('nanoDropFile', '', 'valid');
		nanoDropFileIsValid = true;
	}
	finally
	{
		updateDetailsTable();
	}
	
}


function findColumn(columns, col)
{
	var colIndex = columns.indexOf(col);
	if (colIndex == -1)
	{
		setInputStatus('nanoDropFile', 'On line 1; Can\'t find "' + col + '" column', 'invalid');
	}
	return colIndex;
}

function getNumber(sValue)
{
	return parseFloat(sValue.replace(/,/, '.'));
}

function findRnaOrDna(sampleId, lineNo)
{
	for (var i = 0; i < selectedLysates.length; i++)
	{
		var lysate = selectedLysates[i];
		if (lysate.rna.name == sampleId)
		{
			return lysate.rna;
		}
		else if (lysate.dna.name == sampleId)
		{
			return lysate.dna;
		}
	}
	
	setInputStatus('nanoDropFile', 'On line ' + lineNo + '; Can\'t find RNA/DNA with name "' + sampleId + '"', 'invalid');
}

var FILE_HEADER = ['Well', 'Sample ID', 'Conc.', '260/280', '260/230'];

function generateFakeMeasurementsFile()
{
	if (location.protocol == 'https:')
	{
		alert("For security reasons, this function can't be used on HTTPS servers.");
		return;
	}
	
	var data = FILE_HEADER.join('\t')+'\n';
	
	for (var i = 0; i < 12; i++)
	{
		var line = new Array();
		// DNA 
		line[0] = selectedLysates[i].dna.well;
		line[1] = selectedLysates[i].dna.name;
		line[2] = Numbers.formatNumber(Math.random()*100+10, 2);
		line[3] = Numbers.formatNumber(Math.random()*.5+2, 2);
		line[4] = Numbers.formatNumber(Math.random()+1, 2);
		data += line.join('\t') + '\n';
		// RNA
		line[0] = selectedLysates[i].rna.well;
		line[1] = selectedLysates[i].rna.name;
		line[2] = Numbers.formatNumber(Math.random()*100+10, 2);
		line[3] = Numbers.formatNumber(Math.random()*.5+2, 2);
		line[4] = Numbers.formatNumber(Math.random()+1, 2);
		data += line.join('\t') + '\n';
	}
		
	parseNanoDropFile(data);
}

</script>


</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="index.jsp?ID="+ID%>" 
		/><p:pathelement title="DNA/RNA/FlowThrough registration" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>	

	<div class="allsteps">
		<div class="step current" id="step.1">1</div>
		›
		<div class="step future" id="step.2">2</div>
		›
		<div class="step future" id="step.3">3</div>
	</div>

	<form name="reggie" onsubmit="return false;">
	
	<!-- 1. Lysate items -->
	<table id="step.1.section" class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Select unprocessed lysate items</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
			<tr valign="top">
				<td class="prompt">Lysate</td>
				<td class="input" rowspan="2">
					<select style="width:90%" name="lysates" id="lysates" multiple="multiple" size="15" onchange="lysatesOnChange()"></select>
				</td>
				<td class="status" id="lysate.status" rowspan="2"></td>
				<td class="help" rowspan="2"><span id="lysate.message" class="message" style="display: none;"></span>
					Select 12 items. The list contain Lysate items that has not yet been processed
					(determined by absence of a 'creation' date).
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	
	<!-- 2. Lysis + Qiacube information -->
	<table id="step.2.section" class="stepform" style="display: none;">
	<tr>
		<td rowspan="2" class="stepno">2</td>
		<td class="steptitle">Common information from Lysate and Qiacube step</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table border="0" cellspacing="0" cellpadding="0" width="100%" style="border-collapse: collapse;">
			<tr>
				<td class="prompt">Lysis</td>
				<td class="input"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr>
				<td class="subprompt">Date</td>
				<td class="input"><input type="text" name="lysisDate" value="<%=dateFormat.format(new Date()) %>" size="12" maxlength="10"
						onblur="lysisOrQiacubeDateOnChange()" onkeypress="focusOnEnter(event, 'lysisProtocol')">
				</td>
				<td class="status" id="lysisDate.status"></td>
				<td class="help"><span id="lysisDate.message" class="message" style="display: none;"></span>(YYYYMMDD or MMDD)</td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Protocol</td>
				<td class="input"><select style="width:90%" name="lysisProtocol" id="lysisProtocol" 
					onkeypress="focusOnEnter(event, 'qiacubeDate')"></select></td>
				<td class="status" id="lysisProtocol.status"></td>
				<td class="help"><span id="lysisProtocol.message" class="message" style="display: none;"></span>
					Select the protocol which was used in the lysis step.
				</td>
			</tr>
			<tr style="border-top: 1px dotted #A0A0A0;">
				<td class="prompt">Qiacube</td>
				<td class="input"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr>
				<td class="subprompt">Date</td>
				<td class="input"><input type="text" name="qiacubeDate" value="<%=dateFormat.format(new Date()) %>" size="12" maxlength="10"
						onchange="lysisOrQiacubeDateOnChange()" onkeypress="focusOnEnter(event, 'qiacubeRunNo')">
				</td>
				<td class="status" id="qiacubeDate.status"></td>
				<td class="help"><span id="qiacubeDate.message" class="message" style="display: none;"></span>(YYYYMMDD or MMDD)</td>
			</tr>
			<tr>
				<td class="subprompt">Run number</td>
				<td class="input"><input type="text" name="qiacubeRunNo"
					value="1" size="12" maxlength="10" onblur="qiacubeRunNoOnChange()" onkeypress="focusOnEnter(event, 'qiacubeOperator')">
				</td>
				<td class="status" id="qiacubeRunNo.status"></td>
				<td class="help"><span id="qiacubeRunNo.message" class="message" style="display: none;"></span></td>
			</tr>
			<tr>
				<td class="subprompt">Operator</td>
				<td class="input" style="padding-left: 0px;">
					<input type="text" name="qiacubeOperator" value="<%=HTML.encodeTags(user.getName()) %>" 
						size="30" maxlength="255" onkeypress="focusOnEnter(event, 'dnaProtocol')">
				</td>
				<td class="status" id="qiacubeOperator.status"></td>
				<td class="help">
					<span id="qiacubeOperator.message" class="message" style="display: none;"></span>
				</td>
			</tr>
			<tr valign="top">
				<td class="subprompt">DNA protocol</td>
				<td class="input"><select style="width:90%" name="dnaProtocol" id="dnaProtocol" onkeypress="focusOnEnter(event, 'rnaProtocol')"></select></td>
				<td class="status" id="dnaProtocol.status"></td>
				<td class="help"><span id="dnaProtocol.message" class="message" style="display: none;"></span>
					Select the protocol which was used for DNA extraction.
				</td>
			</tr>
			<tr valign="top">
				<td class="subprompt">RNA protocol</td>
				<td class="input"><select style="width:90%" name="rnaProtocol" id="rnaProtocol" onkeypress="focusOnEnter(event, 'ftProtocol')"></select></td>
				<td class="status" id="rnaProtocol.status"></td>
				<td class="help"><span id="rnaProtocol.message" class="message" style="display: none;"></span>
					Select the protocol which was used for RNA extraction.
				</td>
			</tr>
			<tr valign="top">
				<td class="subprompt">FlowThrough protocol</td>
				<td class="input"><select style="width:90%" name="ftProtocol" id="ftProtocol"></select></td>
				<td class="status" id="ftProtocol.status"></td>
				<td class="help"><span id="ftProtocol.message" class="message" style="display: none;"></span>
					Select the protocol which was used for FlowThrough extraction.
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	
	<!-- 2. DNA/RNA/FT information -->
	<table id="step.3.section" class="stepform" style="display: none;">
	<tr>
		<td rowspan="2" class="stepno">3</td>
		<td class="steptitle">RNA/DNA/FlowThrough details</td>
	</tr>
	<tr>
		<td class="stepfields">
			<div style="background: #E8E8E8; padding: 2px; border-bottom: 1px dotted #A0A0A0;">
				The table below show values from the Qiacube run.
				<span class="nondefault">Highlighted</span> values have been manually 
				changed from their default values. If the Qiacube positions are not correct,
				they must be fixed before the <i>NanoDrop Sample ID</i> file is downloaded
				since the order in this file depends on the positions. The concentrations
				and other values are loaded from the file after the NanoDrop has been completed.
			</div>

			<div id="detailsSection">
			</div>

			<table style="width: 100%; border-collapse: collapse;">
			<tr style="border-top: 1px dotted #A0A0A0;">
				<td class="prompt">NanoDrop Sample ID</td>
				<td class="input">
					<base:button id="downloadSampleIdFile" title="Download..." onclick="downloadSampleIdFile()" 
						image="<%=home + "/images/download.png"%>" style="width:115px" />
				</td>
				<td class="status" id="downloadSampleIdFile.status"></td>
				<td class="help"><span id="downloadSampleIdFile.message" class="message" style="display:none;"></span>
					Download and import this file to the NanoDrop software before analyzing the DNA/RNA.
					<b>Note that the samples are sorted by Qiacube position!</b>
				</td>
			</tr>
			<tr>
				<td class="prompt">NanoDrop values</td>
				<td class="input">
					<input type="file" name="nanoDropFile" onchange="nanoDropFileOnChange()" accept="text/plain" size="30">
				</td>
				<td class="status" id="nanoDropFile.status"></td>
				<td class="help"><span id="nanoDropFile.message" class="message" style="display:none;"></span>
					Select the file containing measurements from the NanoDrop.
				</td>
			</tr>
			<tr id="generateFakeMeasurementsFile" style="display: none;">
				<td class="prompt"></td>
				<td class="input">
					<base:button id="" title="Generate fake data..." onclick="generateFakeMeasurementsFile()" 
						image="<%=home + "/images/extraction.png"%>" style="width:165px" />
					
				</td>
				<td class="status"></td>
				<td class="help"><span id="nanoDropFile.message" class="message" style="display:none;"></span>
					Generates fake data for all NanoDrop measurements. USE FOR DEBUGGING ONLY!
					DO NOT USE ON PRODUCTION SERVER!
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>	
	
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="done" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>
	
	<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;"/></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" onclick="goNext(true)"/></td>
		<td><base:button id="gocreate" title="Finish" image="<%=home+"/images/gonext.png"%>" onclick="goCreate()" style="display: none;"/></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
		<td><base:button id="rnaQcWizard" title="Continue with RNA QC registration on Caliper plate" image="<%=home+"/images/gonext.png"%>" onclick="goRnaQc()" style="display:none;" /></td>
		<td id="gonext.message" class="message"></td>
	</tr>
	</table>
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>